/*
pma.c

this is the client of pma. basically all it does is get a string
from the terminal and write it out to an established socket.
*/
#include <stdio.h>
#include <signal.h>
#include <sys/types.h>
#include <sgtty.h>

char buf[5000], tbuf[100];
int  sockfd, vimode = 0;
struct sgttyb tty_mode;

main(int argc, char *argv[])
{
int cnt, port, pid, idx = 0;
FILE *lout;

if (argc < 3)
	{
	fprintf(stderr, "Specify host and port\n");
	exit(0);
	}
signal(SIGCHLD, SIG_IGN);		/*dont create any zombies*/
ioctl(0, TIOCGETP, &tty_mode);
fprintf(stderr, "Trying...");
port = atoi(argv[2]);
/*
see if there is a server on the user given host and port
*/
sockfd = socket_connect(argv[1], port);
if (sockfd == -1)
	{
	fprintf(stderr, "\nsocket_connect(pma) failed\n");
	exit(1);
	}
fprintf(stderr, "\nConnected\n");
pid = forkio();
cnt = write(sockfd, buf, strlen(buf));
while (1)
	{
	if (!vimode)
		{
		gets(&buf[idx]);
		idx = 0;
		}
	else
		{
		buf[0] = getchar();
		vimode = checkmode();
		if (!vimode)
			{
			idx = 1;
			continue;
			}
		buf[1] = '\0';
		}
	checkcmd(pid);
	cnt = write(sockfd, buf, strlen(buf));
	}
}

int forkio()
{
int pid;

/*
fork off a child which endlessly reads from the socket and writes to
the terminal.
*/

if ((pid = fork()) < 0)
        exit(system("echo fork error in forkio >>pma.log"));
else if (pid > 0)
        return(pid);
while(1)
        rdsock();
}

int rdsock()
/*
if we see the prompt, "PMA> ", it means that we could be coming out vi
mode. so turn on echo and turn off raw mode. note that our parent will
get to the getchar() before it sees that echo is back on. this means
that the first character typed after exiting from vi will not go to
the gets() like we would really want. that first character can be flakey
sometimes, but it basically works.
*/
{
int cnt;

cnt = read(sockfd, buf, sizeof(buf));
buf[cnt] = '\0';
fprintf(stderr, "%s", buf);
if (!strcmp(&buf[strlen(buf)-5], "PMA> "))
	echo();
}

int checkmode()
{

struct sgttyb tty_mode;
int mode;

ioctl(0, TIOCGETP, &tty_mode);
if (tty_mode.sg_flags & ECHO)
	mode = 0;
else
	mode = 1;
return(mode);
}

int noecho()
{

/*system("stty -echo;stty raw");*/
tty_mode.sg_flags &= ~ECHO;
tty_mode.sg_flags |= RAW;
ioctl(0, TIOCSETP, &tty_mode);
}

int echo()
{

/*system("stty echo;stty cooked");*/
tty_mode.sg_flags |= ECHO;
tty_mode.sg_flags &= ~RAW;
ioctl(0, TIOCSETP, &tty_mode);
}

int checkcmd(int pid)
{

if (!strcmp(buf, "done"))
	exit(kill(pid,9));
if (!vimode)
	strcat(buf,"\n");
if (!strncmp(buf, "vi ", 3))
	{
	noecho();
	vimode = 1;
	strcpy(tbuf, "vi -w24");
	strcat(tbuf,&buf[2]);
	strcpy(buf, tbuf);
	}
}
