/* generic packet spoofing routines. 
 * Michael R. Widner
 */

#ifndef __PACKET_SPOOF__
#define __PACKET_SPOOF__
/* Pretty generous group of includes.  Someday I'll narrow this list. */
#include <sys/param.h>
#include <sys/socket.h>
#include <sys/file.h>
#include <sys/time.h>
#include <sys/signal.h>

#ifdef LINUX
#include <bsd/netinet/in_systm.h>
#include <bsd/netinet/in.h>
#include <bsd/netinet/ip.h>
#include <bsd/netinet/ip_icmp.h>
#include <bsd/netinet/ip_var.h>
#include <bsd/netinet/tcp.h>
#include <bsd/netinet/udp.h>
#include <bsd/netinet/if_ether.h>
#else
#include <netinet/in_systm.h>
#include <netinet/in.h>
#include <netinet/ip.h>
#include <netinet/ip_icmp.h>
#include <netinet/ip_var.h>
#include <netinet/tcp.h>
#include <netinet/udp.h>
#include <net/if.h>
#include <netinet/if_ether.h>
#endif
#include <netdb.h>
#include <unistd.h>
#include <stdio.h>
#include <ctype.h>
#include <string.h>

u_short in_cksum(u_short *, int);

int build_ip_header(u_char *, u_long, u_long, int, u_char);

int build_tcp_packet(u_char *,u_char *,int, u_long, u_short,
		u_long, u_short, u_long, u_long, u_char);

int build_udp_packet(u_char *,u_char *,int,u_long,u_short,
	u_long,u_short);

struct ether_addr *ether_a2e (char *);

int sendtcppacket_simple(struct ether_addr *, struct ether_addr *,
	 u_long, u_long, u_short, u_short, u_long, u_long, int, char *, int);

int sendudppacket_simple(struct ether_addr *, struct ether_addr *,
	 u_long, u_long, u_short, u_short, char *, int);

int send_raw_packet(struct ether_addr *, u_char *, int);
#endif
