/* System specific routines for packet spoofing.  This is an ugly way to
 * do things, but what the hell.
 * Michael R. Widner
 */

/* This should compile under bsd or sysv. */
#ifdef SYSV
#define bcopy(b1,b2,len) memmove(b2, b1, (size_t)(len))
#define bzero(b,len) memset(b, 0, (size_t)(len))
#endif

#define MAXPACKET       (65536 - 60 - 8)

/* Pretty generous group of includes.  Someday I'll narrow this list. */
#include <sys/param.h>
#include <sys/socket.h>
#include <sys/file.h>
#include <sys/time.h>
#include <sys/signal.h>

#include <netdb.h>
#include <unistd.h>
#include <stdio.h>
#include <ctype.h>
#include <string.h>

/* The lone etherlib include. */
#include <ether.h>

/* a global file descriptor */
int ether_fd=-1;

/* send_raw_packet(char *packet, int packet_size)
 * Send out the packet on whatever interface we're using. */
int send_raw_packet(edest, packet, packet_size)
	u_char *edest;
	u_char *packet;
	int packet_size;
{
	ether_addr e_address;
	struct etherpacket eth_packet;

	eth_packet.pktbuf=packet;
	
	/* Only open the ethernet descriptor once. */
	if (ether_fd==-1)
	if ((ether_fd=ether_open(NULL,0x0800,(ether_addr *)NULL))<0)
		perror("ether open");

	/* copy the ethernet dest addr into the packet */
	bcopy(edest,(char *)&eth_packet.dest,sizeof(ether_addr));
	eth_packet.pktlen=packet_size;
	if (ether_write(ether_fd,&eth_packet)<0)
		perror("ether write");
	if (ether_blocking(ether_fd,0))
		perror("ether blocking");
}
