/* System specific routines for packet spoofing.  This is an ugly way to
 * do things, but what the hell.
 * Michael R. Widner
 */

/* Define this somewhere.  Preferably in your Makefile. */
#ifndef ROUTER_IP
#define ROUTER_IP "0.0.0.0"
#endif

/* This should compile under bsd or sysv. */
#ifdef SYSV
#define bcopy(b1,b2,len) memmove(b2, b1, (size_t)(len))
#define bzero(b,len) memset(b, 0, (size_t)(len))
#endif

/* Linux appears to need me to include endian.h.  */
#include <endian.h>
char *ether_int="eth0";
char *slip_int="sl0";
char *ppp_int="pp0";
char *interface;
int raw_socket=-1;
struct sockaddr whereto;
#define LINUX_INTERFACE "eth0"

/* maximum size of anything we're going to play with. */
#define MAXPACKET       (65536 - 60 - 8)

/* Pretty generous group of includes.  Someday I'll narrow this list. */
#include <sys/param.h>
#include <sys/socket.h>
#include <sys/file.h>
#include <sys/time.h>
#include <sys/signal.h>

#include <bsd/netinet/in_systm.h>
#include <bsd/netinet/in.h>
#include <bsd/netinet/ip.h>
#include <bsd/netinet/ip_icmp.h>
#include <bsd/netinet/ip_var.h>
#include <bsd/netinet/tcp.h>
#include <bsd/netinet/udp.h>
#include <bsd/netinet/if_ether.h>
#include <netdb.h>
#include <unistd.h>
#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <malloc.h>
#include <arpa/inet.h>

#include "packet_spoof.h"
/*
 * build_linux_ether - create an ethernet packet header.  aka MAC header.
 *
 */
int build_ether(start_addr,eaddr)
u_char *start_addr;
u_char *eaddr;
{
	int i;

	for(i=0;i<6;i++)
		start_addr[i]=eaddr[i];

	for(;i<12;i++)
		start_addr[i]=0;

        start_addr[12]=0x08;
        start_addr[13]=0x00;
        return(14);  /* ether header is 14 bytes */
}


/*
 * build_linux_mac - Generic routine to build the MAC layer header.
 *                      Calls build_linux_ether or slip or whatever.
 *                      MAC=Media Access Control.  The real low level shit.
 */
int build_mac(start_addr,eaddr)
u_char *start_addr;
struct ether_addr *eaddr;
{
#ifdef LINUX_USE_SOCKET
        /* for sockets interface there is no MAC layer */
/*        if ((options & F_SOCKET)) */
                return(0);
#endif
#ifdef LINUX_USE_SLIP
        /* for slip interface there is no MAC layer */
/*        if ((options & F_SLIP)) */
                return(0);
#endif
#ifdef LINUX_USE_PPP
        /* I dont know what the hell to do with ppp */
/*        if ((options & F_PPP)) */
                return(0); 
#endif
        /* If we get here, it must be ethernet */
        /* for ethernet we need a 14 byte header */
        return(build_ether(start_addr,eaddr));

}

/* open_raw_ether()
 * opens the raw socket on which we can spit out ethernet packets.
 * pretty much the same for slip or ppp, but the device name changes.
 * Choices are "eth0", "sl0" or "pp0", set LINUX_INTERFACE up top
 * appropriately.
 */
int open_raw_ether()
{
	struct sockaddr_in *to;

	bzero((char *)&whereto, sizeof(struct sockaddr));
	to=(struct sockaddr_in *)&whereto;


	if ((raw_socket = socket(AF_INET,SOCK_PACKET,htons(0x0800))) < 0) {
		perror("open_raw_ether: socket");
		return(1);
	}

        to->sin_family = AF_INET;
        to->sin_addr.s_addr = inet_addr(ROUTER_IP); /* 1.2.3.4 to u_long */
        if (to->sin_addr.s_addr != (u_int)-1)
                printf("Sending to router %s\n",ROUTER_IP);
        else {                                   /* it's a name, look it up */
		printf("Cant interpret router: %s\n",ROUTER_IP);
        }

	strcpy(whereto.sa_data,LINUX_INTERFACE);

	return(0);
}


/* send_raw_packet(u_char *edest, u_char *packet, int packet_size)
 * Send out the packet on whatever interface we're using. */
int send_raw_packet(edest, packet, packet_size)
	struct ether_addr *edest;
	u_char *packet;
	int packet_size;
{
	int header_size;
	u_char *ether_packet, *next_loc;

	ether_packet=(u_char *)malloc(MAXPACKET);

	if (raw_socket==-1) open_raw_ether();

	/* Make up the ethernet header, if needed */
	header_size=build_mac(ether_packet,edest);
	next_loc=(void *)ether_packet+header_size;
	memcpy(next_loc,packet,packet_size);

	return(sendto(raw_socket,(char *)ether_packet,
		packet_size+header_size, 0, &whereto,
		sizeof(struct sockaddr)));
}
