/* Log wrappers incase I decide to change the way things are logged. 
  The source code may be redistributed, as long it remains intact, and
  with this License included. You may modify or use this source code in
  anyway you see fit, but credit must be given where applicable.

  This software comes with NO warranty, and the author is NOT liable for
  any damages which may come from the use of this software.

  You may not use the name of the author to promote this software.

  shadows@whitefang.com (Thamer AL-Herbish)

 */

#include <stdlib.h>
#include <stdio.h>

#include <config.h>

#include <syslog.h>
#include <stdarg.h>


void init_log(char *s)
{
  openlog(s,LOG_OPT,LOG_FACILITY);
  return;
}

void close_log(void)
{
  closelog();
  return;
}

void error_log(char *m,...)
{
  va_list ap;
  va_start(ap,m);

  vsyslog(ERROR_LEVEL,m,ap);
  return;
}

void info_log(char *m,...)
{
  va_list ap;
  va_start(ap,m);
  vsyslog(INFO_LEVEL,m,ap);
  return;
}
